// ProfileSection.cpp : CProfileSection ̃Cve[V
#include "stdafx.h"
#include "SeraphyScriptTools.h"
#include "ProfileSection.h"

/////////////////////////////////////////////////////////////////////////////
// CProfileSection

STDMETHODIMP CProfileSection::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISeraphyScriptTools_ProfileSection
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (IsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CProfileSection::get_Value(VARIANT idx, VARIANT *pVal)
{
	::VariantInit(pVal);

	ATL::CString szKeyname;
	CComVariant varIdx;
	if (varIdx.ChangeType(VT_BSTR, &idx) == S_OK){
		szKeyname = varIdx.bstrVal;
	}

	const int siz = 1024 * 8; // 8KBytes
	ATL::CString buf;
	LPTSTR szReturn = buf.GetBufferSetLength(siz);
	if (GetPrivateProfileString(m_szSectionName, szKeyname, _TEXT(""), szReturn, siz, m_szProfilePath)) {
		CComVariant ret(szReturn);
		ret.Detach(pVal);
	}
	return S_OK;
}

STDMETHODIMP CProfileSection::put_Value(VARIANT idx, VARIANT newVal)
{
	// fBtHg̒l擾

	ATL::CString szKeyname;
	CComVariant varIdx;
	if (varIdx.ChangeType(VT_BSTR, &idx) == S_OK) {
		szKeyname = varIdx.bstrVal;
	}

	ATL::CString szWrite;
	CComVariant varNew;
	if (varNew.ChangeType(VT_BSTR, &newVal) == S_OK){
		szWrite = varNew.bstrVal;
	}

	WritePrivateProfileString(m_szSectionName, szKeyname, szWrite, m_szProfilePath);
	return S_OK;
}

STDMETHODIMP CProfileSection::GetValue(VARIANT idx, VARIANT def,VARIANT* pVal)
{
	// fBtHg̒l擾
	::VariantInit(pVal);

	ATL::CString szKeyname;
	CComVariant varIdx;
	if (varIdx.ChangeType(VT_BSTR, &idx) == S_OK) {
		szKeyname = varIdx.bstrVal;
	}

	ATL::CString szDefault;
	CComVariant varDef;
	if (varDef.ChangeType(VT_BSTR, &def) == S_OK) {
		szDefault = varDef.bstrVal;
	}

	const int siz = 1024 * 8; // 8KBytes
	ATL::CString buf;
	LPTSTR szReturn = buf.GetBufferSetLength(siz);
	if (GetPrivateProfileString(m_szSectionName, szKeyname, szDefault, szReturn, siz, m_szProfilePath)) {
		CComVariant ret(szReturn);
		ret.Detach(pVal);
	}
	return S_OK;
}

STDMETHODIMP CProfileSection::GetKeyNames(VARIANT *pVal)
{
	// L[̗񋓂s
	DWORD siz = 4096;
	DWORD oldsiz = 0;
	DWORD retsiz = 0;
	LPTSTR pBuf = new TCHAR[siz];
	while ((retsiz = GetPrivateProfileSection(m_szSectionName, pBuf, siz, m_szProfilePath)) &&
			(retsiz == (siz - 2)) && (oldsiz != retsiz)) {
		oldsiz = siz;
		siz *= 2;
		delete []pBuf;
		pBuf = new TCHAR[siz];
	}
	// JEg
	LPTSTR p = pBuf;
	long count = 0;
	while (*p) {
		count++;
		while (*p++);
	}
	// ꎟz̐
	SAFEARRAY* pArray = SafeArrayCreateVector(VT_VARIANT, 0, count);
	long idx = 0;
	p = pBuf;
	while (*p) {
		CComVariant tmp;
		LPCTSTR pb = p;
		while (*p) {
			if (*p == '=') {
				*p = 0;
			}
			p++;
		}
		p++;
		tmp = (LPCSTR)pb;
		SafeArrayPutElement(pArray,&idx,&tmp);
		tmp.Clear();
		idx++;
	}
	delete[]pBuf;
	// ߂l
	::VariantInit(pVal);
	pVal->vt     = VT_VARIANT | VT_ARRAY;
	pVal->parray = pArray;
	return S_OK;
}
